package com.clx.performance.controller.temp;

import com.clx.order.vo.feign.FeignAddressVO;
import com.clx.performance.extranal.user.AddressService;
import com.clx.performance.service.linewarn.LineWarnMqService;
import com.clx.performance.utils.gd.GdUtils;
import com.msl.common.base.Optional;
import com.msl.common.result.Result;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author: aiqingguo
 * @Description: 临时接口
 * @Date: 2023-8-21 12:10:16
 * @Version: 1.0
 */
@Slf4j
@RestController
@RequestMapping(value="/temp/lineWarn")
public class TempLineWarnController {

    @Autowired
    private LineWarnMqService lineWarnMqService;
    @Autowired
    private AddressService addressService;
    @Autowired
    private GdUtils gdUtils;

    @ApiOperation(value = "test", notes = "<br>By:艾庆国")
    @PostMapping("/test")
    public Result test() {

        return Result.ok();
    }

    @ApiOperation(value = "运单异常", notes = "<br>By:艾庆国")
    @PostMapping("/orderChildWarn")
    public Result orderChildWarn(String orderGoodsNo, String childNo) {

        lineWarnMqService.orderChildWarn(orderGoodsNo, childNo);
        return Result.ok();
    }

    @ApiOperation(value = "货单新增", notes = "<br>By:艾庆国")
    @PostMapping("/orderGoodsAdd")
    public Result orderGoodsAdd(String orderGoodsNo) {

        lineWarnMqService.orderGoodsAdd(orderGoodsNo);
        return Result.ok();
    }
    @ApiOperation(value = "天气", notes = "<br>By:艾庆国")
    @PostMapping("/orderGoodsAdd")
    public Result<Map<String, String>> orderGoodsAdd(Integer sendAddressId, Integer receiveAddressId) {
        Map<String, String> result = new HashMap<>();

        Optional<FeignAddressVO> addressOptional = addressService
                .getSendAndReceiveAddress(sendAddressId, receiveAddressId);
        if (addressOptional.isEmpty()) {return Result.ok(result);}
        FeignAddressVO feignAddressVO = addressOptional.get();


        if (feignAddressVO.getSendAddress()!=null
                && StringUtils.isNotBlank(feignAddressVO.getSendAddress().getCityCode())){
            String weather = gdUtils.getWeather(feignAddressVO.getSendAddress().getCityCode());
            result.put("send", weather);
        }

        if (feignAddressVO.getReceiveAddress()!=null
                && StringUtils.isNotBlank(feignAddressVO.getReceiveAddress().getCityCode())){
            String weather = gdUtils.getWeather(feignAddressVO.getReceiveAddress().getCityCode());
            result.put("receive", weather);

        }

        return Result.ok(result);
    }

}
